#include <owl\applicat.h>
#include <owl\decframe.h>
#include <owl\controlb.h>
#include <owl\buttonga.h>
#include "pr42_1.rc"

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw : public TDecoratedFrame
{
  public:
	  TWndw(TWindow *parent, const char far *title, TWindow *client);
  protected:
	  void CmFileNew();
	  void CmFileOpen();
	  void CmFileSave();
	  void CmMax();
	  void CmRestore();
	  //   .
	  void CmEnableMax (TCommandEnabler &commandEnabler);
	  void CmEnableRestore (TCommandEnabler &commandEnabler);

	  DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TDecoratedFrame)
	EV_COMMAND(CM_FILENEW, CmFileNew),
	EV_COMMAND(CM_FILEOPEN, CmFileOpen),
	EV_COMMAND(CM_FILESAVE, CmFileSave),
	EV_COMMAND(CM_MAX, CmMax),
	EV_COMMAND(CM_RESTORE, CmRestore),
	EV_COMMAND_ENABLE(CM_MAX, CmEnableMax),
	EV_COMMAND_ENABLE(CM_RESTORE, CmEnableRestore),
END_RESPONSE_TABLE;

TWndw::TWndw(TWindow *parent, const char far *title, TWindow *clientWnd):
		  TDecoratedFrame(parent,title, clientWnd)
{
  TButtonGadget *b;
  TSeparatorGadget *s;
  //     .
  AssignMenu("MENU_1");
  TControlBar *cntrlBar = new TControlBar(this);
  //     .
  b = new TButtonGadget(BMP_NEW, CM_FILENEW);
  cntrlBar->Insert(*b);
  b = new TButtonGadget(BMP_OPEN, CM_FILEOPEN);
  cntrlBar->Insert(*b);
  b = new TButtonGadget (BMP_SAVE, CM_FILESAVE);
  cntrlBar->Insert(*b);
  s = new TSeparatorGadget(10);
  cntrlBar->Insert(*s);
  b = new TButtonGadget(BMP_MAX, CM_MAX);
  cntrlBar->Insert(*b);
  b = new TButtonGadget(BMP_RESTORE, CM_RESTORE);
  cntrlBar->Insert(*b);
  s = new TSeparatorGadget(10);
  cntrlBar->Insert (*s);
  b = new TButtonGadget(BMP_EXIT, CM_EXIT);
  cntrlBar->Insert(*b);
  //     .
  Insert(*cntrlBar, TDecoratedFrame::Top);
  //     .
  Attr.X = 50;
  Attr.Y = 50;
  Attr.W = GetSystemMetrics(SM_CXSCREEN) / 1.5;
  Attr.H = GetSystemMetrics(SM_CYSCREEN) / 1.5;
}

// TWndw::CmFileNew()
//      CM_FILENEW,
//    New  
//    NEW.
void TWndw::CmFileNew()
{
  MessageBox ("  FILENEW", "",MB_OK);
}

// TWndw::CmFileOpen()
//      CM_FILEOPEN,
//    Open  
//    OPEN.
void TWndw::CmFileOpen()
{
  MessageBox ("  FILEOPEN", "",MB_OK);
}

// TWndw::CmFileSave()
//      CM_FILESAVE,
//    Save  
//    SAVE.
void TWndw::CmFileSave()
{
  MessageBox ("  FILESAVE", "",MB_OK);
}

//TWndw::CmRestore()
//      _RESTORE, 
//   RES  .
void TWndw::CmRestore()
{
  //       .
  SendMessage(WM_SYSCOMMAND, SC_RESTORE, 0);
}


//TWndw::CmMax()
//      _A, 
//     .
void TWndw::CmMax()
{
  //      .
  SendMessage(WM_SYSCOMMAND, SC_MAXIMIZE, 0);
}

//TWndw::CmEnableMax()
//     
//  MAX  .
void TWndw::CmEnableMax (TCommandEnabler &commandEnabler)
{
  //   MAX,   
  // ;   
  //   MAX.
  commandEnabler.Enable(!IsZoomed());
}

//TWndw::CmEnableRestore()
//     
//  RES  .
void TWndw::CmEnableRestore(TCommandEnabler &commandEnabler)
{
  //   RES,  
  // ;   
  //   RES.
  commandEnabler.Enable(IsZoomed());
}

void TApp::InitMainWindow()
{
  //  TDecoratedFrame   -.
  TWindow *client = new TWindow (0,0,0);
  //   .
  TDecoratedFrame *wndw= new TWndw(0,"  ",client);
  //    MainWindow .
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
